package cn.net.cpzslibs.prot.handset.newProt;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20032ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20046ResBean;

public class Prot20046ReqYthOrder extends ProtBase {

	private final short iTaskCode20046 = 20046;
	private Gson gson;
	private Prot20046ResBean resBean;

	public Prot20046ReqYthOrder() {
		// this.sInspectorId = sInspectorId;
		gson = new Gson();
	}

	public Prot20046ResBean getResBean() {
		return this.resBean;
	}

	public void reqOrderInfoByOrderId(SocketCreate create, Prot20032ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(),reqBean);
	}

	private void recProt(Socket socket, DataOutputStream dos, DataInputStream dis, Prot20032ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode20046, "开始请求运单信息 列表");
				sendProt(dos,reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
					//服务器可能分多次包返回数据
					recLoginDis(dis);
			}
		}
	}


	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20046, jsonData);
		resBean = gson.fromJson(jsonData, Prot20046ResBean.class);

		recCheckCode(dis);
		
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot20032ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
//		String bodyContent = "{}";
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20046, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}
